#define MEMCPY32 -1
#define FIXED32 0
#define ELIAS_DELTA 1
#define ELIAS_DELTA_FAST 5
#define FIBONACCI2 2
#define FIBONACCI2_FAST 6
#define FIBONACCI3 3
#define FIBONACCI3_FAST 7
#define ELIAS_FIBONACCI 4
#define ELIAS_FIBONACCI_FAST 8

namespace FastCodingLibrary {

	class Coder
	{
		public:
			static __declspec(dllexport) unsigned int encode(int method,int bytePerNumber
							  , char * sourceBuffer, char * encodedBuffer
							  ,unsigned int count);

			static __declspec(dllexport) unsigned int decode(int method,int bytePerNumber
							  , char * encodedBuffer, char * decodedBuffer
							  ,unsigned int count);

			static __declspec(dllexport) char * methodName(int method);

			static __declspec(dllexport) unsigned int estimateSizeInBits(int method,int bytePerNumber
							   , char * sourceBuffer,unsigned int count);

			static __declspec(dllexport) void print(int method, char * buffer,unsigned int bytes);
	};
}